#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_STRING 100

typedef struct _DETE DETE;
typedef struct _LISTA LISTA;

struct _DETE
{
	char *ime;
	char *otac;
	char *majka;
};

struct _LISTA
{
	DETE *data;
	LISTA *next;
};

char *kreiraj_string(int broj)
{
	char *temp;
	
	temp = (char *) malloc((broj + 1) * sizeof(char));
	
	return temp;
}

DETE *kreiraj_dete()
{
	DETE *temp;
	
	temp = (DETE *) malloc(sizeof(DETE));
	
	return temp;
}

LISTA *kreiraj_element()
{
	LISTA *temp;
	
	temp = (LISTA *) malloc(sizeof(LISTA));
	temp->data = NULL;
	temp->next = NULL;
	
	return temp;
}

void ispis_data(DETE *p)
{
	printf("%s%s%s\n", p->ime, p->otac, p->majka);
}

LISTA *kreiraj_listu(char *fajl)
{
	FILE *f;
	LISTA *glava = NULL, *new, *current;
	DETE *temp;
	char str[MAX_STRING];
	f = fopen(fajl, "r");
	
	while(1)
	{
		fgets(str, MAX_STRING, f);
		
		if (!strcmp(str, "KRAJ\n"))
			break;
		
		new = kreiraj_element();
		temp = kreiraj_dete();
		
		temp->ime = kreiraj_string(strlen(str));
		strcpy(temp->ime, str);
		
		fgets(str, MAX_STRING, f);
		temp->otac = kreiraj_string(strlen(str));
		strcpy(temp->otac, str);
		
		fgets(str, MAX_STRING, f);
		temp->majka = kreiraj_string(strlen(str));
		strcpy(temp->majka, str);
		
		new->data = temp;
		
		if (!glava)
			glava = new;
		else
			current->next = new;
		
		current = new;
	}
	
	return glava;
}

void ispis_liste(LISTA *p)
{
	DETE *temp;
	
	while (p)
	{
		temp = p->data;
		ispis_data(temp);
		p = p->next;
	}
}

int braca(LISTA *p, char *ime)
{
	int count = 0;
	char pretraga[MAX_STRING], otac[MAX_STRING], majka[MAX_STRING];
	
	strcpy(pretraga, ime);
	strcat(pretraga, "\n");
	
	while (p)
	{
		if (strcmp(pretraga, p->data->ime))
		{
			p = p->next;
			continue;
		}
		
		strcpy(otac, p->data->otac);
		strcpy(majka, p->data->majka);
		p = p->next;
		
		while (p)
		{
			if (!strcmp(majka, p->data->majka) || !strcmp(otac, p->data->otac))
				count++;
			p = p->next;
		}
		break;
	}
	
	return count;
}

void brisi_element(LISTA *p)
{
	free(p->data->ime);
	free(p->data->majka);
	free(p->data->otac);
	free(p->data);
	free(p);
}

LISTA *prijem(LISTA *p, char *o, char *m)
{
	char otac[MAX_STRING], majka[MAX_STRING];
	LISTA *glava, *prethodni = NULL;
	
	strcpy(otac, o);
	strcat(otac, "\n");
	strcpy(majka, m);
	strcat(majka, "\n");
	
	glava = p;
	
	while(p)
	{
		if ((!strcmp(otac, p->data->otac)) && (!strcmp(majka, p->data->majka)))
		{
			if (!prethodni)
			{
				glava = p->next;
				brisi_element(p);
				p = glava;
			}
			else
			{
				prethodni->next = p->next;
				brisi_element(p);
				p = prethodni->next;
			}
		}
		else
		{
			prethodni = p;
			p = p->next;
		}
	}
	
	return glava;
}

int main (int argc, char **argv)
{
	LISTA *glava;
	char pretraga[MAX_STRING];
	char majka[MAX_STRING];
	
	glava = NULL;

	if (argc != 2)
	{
		perror("Nisu dobro prosledjeni parametri\n");
		exit(1);
	}
	
	glava = kreiraj_listu(argv[1]);
	ispis_liste(glava);
	
	printf("Unesi ime deteta\n");
	gets(pretraga);
	printf("Uneto dete ima %d brace ili sestara\n", braca(glava, pretraga));
	
	printf("Unesi ime oca\n");
	gets(pretraga);
	printf("Unesi ime majke\n");
	gets(majka);
	printf("\n\n");
	glava = prijem(glava, pretraga, majka);
	ispis_liste(glava);
	
	return 0;
}
